from parser.base_parser import BaseParser
from parser.txt_parser import TXTParser
from parser.pptx_parser import PPTXParser
from parser.pdf_parser import PDFParser
from parser.docx_parser import DOCXParser
#from parser.image_parser import ImageParser
from parser.json_parser import JSONParser
from parser.html_parser import HTMLParser
from parser.md_parser import MDParser
from parser.excel_parser import EXCELParser
from parser.office_parser import OfficeParser

class ParserFactory:
    def __init__(self) -> None:
        pass
    @staticmethod
    def create_parser(format_type: str) -> BaseParser:
        if format_type == "txt":
            return TXTParser()
        elif format_type == "pdf":
            return PDFParser()
        elif format_type == "docx":
            return DOCXParser()
        elif format_type == "pptx":
            return PPTXParser()
        elif format_type == "doc" or format_type == "wps" or format_type == "ppt" or \
            format_type == "uof" or \
            format_type == "uop" or \
            format_type == "uot" or \
            format_type == "uos" or \
            format_type == "dot" or \
            format_type == "pps" or \
            format_type == "dps" or \
            format_type == "et" or \
            format_type == "xls" :
            return OfficeParser()
        # elif format_type == "jpg" or format_type == "png" or format_type == "jpeg":
        #     return ImageParser()
        elif format_type == "json":
            return JSONParser()
        elif format_type == "html" or format_type == "xml":
            return HTMLParser()
        elif format_type == "md":
            return MDParser()
        elif format_type == "xlsx":
            return EXCELParser()
        else:
            raise ValueError(f"Unsupported format: {format_type}")

if __name__ == "__main__":
    import os
    filepath = "/home/wangyan/wangyan/mypro/kylin-ai-parser-extension/test-parser/test.xls"
    file_extension = os.path.splitext(filepath)[1]
    file_format = file_extension[1:]
    parser = ParserFactory.create_parser(file_format)
    print(parser.parser(filepath))